<?php

namespace TMSolution\SmsBundle\Api\SMSApi\Api\Action\Vms;

use TMSolution\SmsBundle\Api\SMSApi\Api\Action\AbstractAction;
use TMSolution\SmsBundle\Api\SMSApi\Api\Response\CountableResponse;
use TMSolution\SmsBundle\Api\SMSApi\Proxy\Uri;

/**
 * Class Delete
 * @package TMSolution\SmsBundle\Api\SMSApi\Api\Action\Vms
 *
 * @method CountableResponse execute()
 */
class Delete extends AbstractAction
{

    /**
     * @var \ArrayObject
     */
    private $id;

    /**
     *
     */
    function __construct()
    {
        $this->id = new \ArrayObject();
    }

    /**
     * @param $data
     * @return CountableResponse
     */
    protected function response($data)
    {
        return new CountableResponse($data);
    }

    /**
     * @return Uri
     */
    public function uri()
    {

        $query = "";

        $query .= $this->paramsLoginToQuery();

        $query .= $this->paramsOther();

        $query .= "&sch_del=" . implode(",", $this->id->getArrayCopy());

        return new Uri($this->proxy->getProtocol(), $this->proxy->getHost(), $this->proxy->getPort(), "/api/vms.do", $query);
    }

    /**
     * Set ID of messages to delete.
     *
     * This id was returned after sending message.
     *
     * @param $id
     * @return $this
     * @throws \TMSolution\SmsBundle\Api\SMSApi\Exception\ActionException
     */
    public function filterById($id)
    {
        if (!is_string($id)) {
            throw new \TMSolution\SmsBundle\Api\SMSApi\Exception\ActionException('Invalid value id');
        }

        $this->id->append($id);
        return $this;
    }

    /**
     *
     * Set array IDs of messages to delete.
     *
     * This id was returned after sending message.
     *
     * @param $ids
     * @return $this
     * @throws \TMSolution\SmsBundle\Api\SMSApi\Exception\ActionException
     */
    public function filterByIds(array $ids)
    {

        $this->id->exchangeArray($ids);
        return $this;
    }

    /**
     * @deprecated since v1.0.0
     */
    public function ids($array)
    {
        return $this->filterByIds($array);
    }

    /**
     * @deprecated since v1.0.0
     */
    public function id($id)
    {
        return $this->filterById($id);
    }

}
