<?php

namespace TMSolution\SmsBundle\DependencyInjection;

use Symfony\Component\Config\Definition\Builder\TreeBuilder;
use Symfony\Component\Config\Definition\ConfigurationInterface;

/**
 * This is the class that validates and merges configuration from your app/config files
 *
 * To learn more see {@link http://symfony.com/doc/current/cookbook/bundles/extension.html#cookbook-bundles-extension-config-class}
 */
class Configuration implements ConfigurationInterface
{

    
    public function getConfigTreeBuilder()
    {
        $treeBuilder = new TreeBuilder();
        $rootNode = $treeBuilder->root('tm_solution_sms');

        $rootNode
            ->children()
                ->arrayNode('smsapi')
                    ->children()
                        ->scalarNode('url')->end()
                        ->scalarNode('username')->end()
                        ->scalarNode('secret_md5')->end()
                        ->scalarNode('partner_affiliate_code')->end()
                    ->end()
                ->end() 
                
                ->arrayNode('gates2n')
                    ->prototype('array')
                        ->children()
                            ->scalarNode('url')->end()
                            ->scalarNode('port')->end()
                            ->scalarNode('username')->end()
                            ->scalarNode('password')->end()
                        ->end()
                    ->end()
                ->end()
            ->end()
        ;

        return $treeBuilder;
    }

}
